function [ Bsplines, DBsplines, Xgrid] = Bspline_bases(knots,ngrid,k)
%Return Bsplines and derivaties in matrices
%Return Xgrid
%k: order of the spline
%step = (knots(end) - knots(1))/ngrid;
Xgrid = linspace(knots(1),knots(end),ngrid);
Xgrid = Xgrid';
nknots1 = length(knots);
knots = [ones(1,k)*knots(1) knots ones(1,k)*knots(end)];
k= k+1;
nknots = length(knots);
BS = cell(1,k);
for i = 1:nknots-1;
    if knots(i)==knots(i+1)||i==nknots;
    B(:,i) = zeros(ngrid,1);
 
    elseif knots(i)<knots(i+1);
        B(:,i)=(Xgrid<knots(i+1)).*(Xgrid>=knots(i));
    elseif knots(i)>knots(i+1);
        disp('not asceding order');
        break;
    end
    BS{1,1} = [B,zeros(ngrid,1)];
end

for i = 2:k;
    BS{1,i} = zeros(ngrid,nknots-k+1);
    for j = 1:nknots-k;

       if knots(j)<knots(j+i-1)&& knots(j+1)<knots(j+i);
            BS{1,i}(:,j) = (Xgrid - knots(j))/(knots(j+i-1)-knots(j)).*BS{1,i-1}(:,j)...
                +(knots(j+i) - Xgrid)/(knots(j+i)-knots(j+1)).*BS{1,i-1}(:,j+1);
        
        elseif knots(j)<knots(j+i-1)&& knots(j+1)==knots(j+i);
            BS{1,i}(:,j) = (Xgrid - knots(j))/(knots(j+i-1)-knots(j)).*BS{1,i-1}(:,j);
           
       elseif knots(j)==knots(j+i-1)&& knots(j+1)<knots(j+i);
        
          BS{1,i}(:,j)= (knots(j+i) - Xgrid)/(knots(j+i)-knots(j+1)).*BS{1,i-1}(:,j+1);
       end
    end
    BS{1,i} = [BS{1,i},zeros(ngrid,1)];
end

for j =1:nknots-k;
    if knots(j)<knots(j+i-1)&& knots(j+1)<knots(j+k);
        DBsplines(:,j) = (k-1)*(-BS{1,k-1}(:,j+1)/(knots(j+k)-knots(j+1))+...
            +BS{1,k-1}(:,j)/(knots(j+k-1)-knots(j)));
        
    elseif knots(j)<knots(j+i-1)&& knots(j+1)==knots(j+k);
        DBsplines(:,j) = ...
            (k-1)*(BS{1,k-1}(:,j)/(knots(j+k-1)-knots(j)));
        
    elseif knots(j)==knots(j+i-1)&& knots(j+1)<knots(j+i);
        
        DBsplines(:,j) = (k-1)*(-BS{1,k-1}(:,j+1)/(knots(j+k)-knots(j+1)));
    end
end


Bsplines = BS{1,k};
Bsplines(end,:) = Bsplines(end-1,:);
DBsplines(end,:) = DBsplines(end-1,:);
Bsplines = Bsplines(:,1:k+nknots1-2);
DBsplines=DBsplines(:,1:k+nknots1-2);


end

