function [y,boot] = bootstrap(B,delta0,data,q,gamma_grid,kappa,gvar )
n=gvar.n;Acon=gvar.Acon;bcon=gvar.bcon;Aeq=gvar.Aeq;beq=gvar.beq;
ID = data(:,2)==1;pbound = gvar.pbound;
N1 = sum(ID);N2=length(data)-N1;N=N1+N2;
databoots= cell(B,1);
options=optimset('algorithm','sqp','MaxFunEvals',50000,'TolCon',1e-8);
lb = [-ones(1,2*(n))*pbound,gvar.corr_lb];
ub = [ones(1,2*(n))*pbound,gvar.corr_ub];
Acon_ext =[Acon;Aeq;-Aeq];bcon_ext = [bcon;beq;-beq];
rng(0)

for b = 1:B
%     bootsID1 = ceil(rand(N1,1)*N1);
%     bootsID2 = ceil(rand(N2,1)*N2);
%     databoots{b} = [data1(bootsID1,:);data2(bootsID2,:)];
    databoots{b} =data(ceil(rand(N,1)*N),:);
end


%options=optimset('algorithm','sqp','MaxFunEvals',50000,'display','off');
boot = zeros(B,length(gamma_grid));
a = zeros(1,length(gamma_grid));
delta1=delta0;
for b = 1:B
    b
    delta0=delta1;
    for j =1 :length(gamma_grid)
        gamma=gamma_grid(j);
        lambda=kappa-gamma^2*(N1+N2);
        if gamma==0
            a(j)=intmboot(data,databoots{b},delta0,gamma,0,gvar);
        else
            %
            [delta,yy1]=fmincon(@(delta)intmboot(data,databoots{b},delta,gamma,lambda,gvar),delta0,Acon,bcon,Aeq,beq,lb,ub,[],options);
            [delta2,yy2]=fminsearchcon(@(delta)intmboot(data,databoots{b},delta,gamma,lambda,gvar),delta,lb,ub,Acon_ext,bcon_ext+1e-8);

            a(j)= intmboot(data,databoots{b},delta2,gamma,0,gvar);
            delta0=delta;
        end
    end
    boot(b,:)=a;
end

if length(gamma_grid)>1
  y = quantile(min(boot,[],2),q);
  y = [y,quantile(min(boot(:,1),boot(:,end)),q),quantile(boot(:,1),q),quantile(boot(:,end),q)];
else
    y=quantile(boot,q);
end

end

