clear;
close all;
%===========================
% Parameters
%===========================

%DGP
Xinvgrid = -10:0.001:10;
Finvgrid = normcdf(Xinvgrid,0,1);
ce=0.3;
nT=100;
s= 1e-4;%step_size for polynormials
Nsim = 3e4; %simulation draws
parg = importdata('pargs.txt');
% hold on
% plot(Xgrid,F1_grid)
% plot(Xgrid,F2_grid,'red')
rng('shuffle')
% covariance matrix for copula

data = importdata('data.xls');
ID = data(:,1)<quantile(data(:,1),0.95);
data=data(ID,:);
data(:,1)=data(:,1)-min(data(:,1));
data(:,1)=data(:,1)/max(data(:,1));
price=sort(data(:,1));
N = sum(ID);%sample size
P_grid = (1:N)'/N;
zgrid =linspace(0,1,1e5);
sosgrid = 2*zgrid-zgrid.^2;


F_grid=interp1(sosgrid,zgrid,P_grid);
Xgrid=price;
Xgrid=(1-1e-8)*Xgrid+1e-8*linspace(0,1,length(Xgrid))';
% ecdf(data{1}(:,1));
% hold on
% plot(Xgrid,F1_grid,'red')
% plot(Xgrid,F2_grid,'red')


%===================================
%generate legendre polynomials
%===================================
knots=linspace(0,1,7);ngrid=1001;sorder=2;
[ Bsplines, DBsplines, vgrid] = Bspline_bases(knots,ngrid,sorder);
nvgrid = length(vgrid);
nstep = floor(nvgrid/10);
Bsplines_pen = Bsplines(1:nstep:end,:);
DBsplines_pen = DBsplines(1:nstep:end,:);
%=====================================
%inference options
%=====================================
rng(0)
T =linspace(-1,1,nT);

u = randn(Nsim,2); %simulation draws
IDgen = (rand(Nsim,1)>0.5);
[~,n]=size(Bsplines);% number of polynomials
%===================
%pass variables
%===================
gvar.T=T;gvar.n=n;gvar.Bsplines=Bsplines;gvar.u=u;
gvar.vgrid=vgrid;gvar.Nsim=Nsim;
gvar.Bsplines_pen=Bsplines_pen;gvar.IDgen=IDgen;
%===================================
%Obtain initial guesses
%===================================
testnull = importdata('null') ;
fx = importdata('fx');

hnull =testnull(1);true=testnull(2);
ID = find(vgrid==fx);
pp = Bsplines(ID,:);
pp0 = Bsplines(1,:);
pp1 = Bsplines(end,:);
gvar.pp=pp;
Aeqs = [pp0;pp1;pp];
Aeqw = [pp0;pp1];beqw=[0;1];
% figure
% hold on
% plot(Xgrid,F_grid,'red')
% plot(Xgrid,F_grid,'magenta')
% plot(vgrid,Bsplines*deltas0(:))
% plot(vgrid,Bsplines*deltaw0(:))





%=================================
%Compute test statistic
%=================================
options=optimset('algorithm','sqp','MaxFunEvals',50000,'TolCon',1e-11,'TolX',1e-8,'TolFun',1e-8);
option=1;
rrl=parg.data(5);
rrh=parg.data(6);
lb = [-ones(1,2*(n))*5,rrl];
ub = [ones(1,2*(n))*5,rrh];
beqs=[0;1;hnull];
Aeq = blkdiag(Aeqs,Aeqw);beq = [beqs;beqw];
constr_opt = parg.data(7);
Acon2 = [blkdiag(-DBsplines,-DBsplines);Bsplines,-Bsplines];bcon2 = zeros(ngrid*3,1);
Aeq1=blkdiag(Aeqs(1:2,:),Aeqw);beq1=[beqs(1:2,:);beqw];
if constr_opt==1
    Acon = [blkdiag(-DBsplines,-DBsplines);Bsplines,-Bsplines];bcon = zeros(ngrid*3,1);
  
else
    Acon = blkdiag(-DBsplines,-DBsplines);bcon = zeros(ngrid*2,1);
  
end
%======================================================
%generating initial values using independence
%======================================================
ID = data(:,2)==1;
data1 = data(ID,1);data2=data(~ID,1);
data1=sort(data1);data2=sort(data2);
Xgrid1=data1;Xgrid2=data2;G1 = (1:sum(ID))/N;G2=(1:sum(1-ID))/N;
[delta_ind,fval]=fmincon(@(delta) inintial(delta,G1,G2,Xgrid1,Xgrid2,gvar),zeros(1,2*n),Acon,bcon,Aeq1,beq1,[],[],[],options); 

F1_grid = Bsplines*delta_ind(1:n)';
F2_grid =  plot(vgrid,Bsplines*delta_ind(n+1:2*n)');


[delta1,fval] = fmincon(@(delta)mean((interp1(vgrid,Bsplines*delta(1:n)',Xgrid)-F_grid).^2)+mean((interp1(vgrid,Bsplines*delta(n+1:2*n)',Xgrid)-F_grid).^2)...
    ,zeros(1,2*n),Acon,bcon,Aeq,beq,[],[],[],options); 
[delta11,fval] = fmincon(@(delta)mean((interp1(vgrid,Bsplines*delta(1:n)',Xgrid)-F_grid).^2)+mean((interp1(vgrid,Bsplines*delta(n+1:2*n)',Xgrid)-F_grid).^2)...
    ,zeros(1,2*n),Acon2,bcon2,Aeq,beq,[],[],[],options); 

[delta_new1,fval] = fmincon(@(delta)mean((interp1(vgrid,Bsplines*delta(1:n)',Xgrid)-P_grid).^2)+mean((interp1(vgrid,Bsplines*delta(n+1:2*n)',Xgrid)-P_grid).^2)...
    ,ones(1,2*n),Acon,bcon,Aeq,beq,[],[],[],options); 
[delta_new2,fval] = fmincon(@(delta)mean((interp1(vgrid,Bsplines*delta(1:n)',Xgrid)-F_grid).^2)+mean((interp1(vgrid,Bsplines*delta(n+1:2*n)',Xgrid)-F_grid).^2)...
    ,zeros(1,2*n),Acon2,bcon2,Aeq,beq,[],[],[],options); 

[delta_new3,fval] = fmincon(@(delta)mean((interp1(vgrid,Bsplines*delta(1:n)',Xgrid)-P_grid).^2)+mean((interp1(vgrid,Bsplines*delta(n+1:2*n)',Xgrid)-P_grid).^2)...
    ,ones(1,2*n),Acon,bcon,Aeq1,beq1,[],[],[],options); 
%  figure
%  hold on
% % plot(Xgrid,F_grid,'red')
%  plot(Xgrid,P_grid,'magenta')
%  plot(vgrid,Bsplines*delta_ind(1:n)')
%  plot(vgrid,Bsplines*delta_ind(n+1:2*n)')

if constr_opt==1
    Acon = [Acon,zeros(ngrid*3,1)];Aeq = [Aeq,zeros(5,1)];
    Acon_ext =[Acon;Aeq;-Aeq];bcon_ext = [bcon;beq;-beq];
else
    Acon = [Acon,zeros(ngrid*2,1)];Aeq = [Aeq,zeros(5,1)];
    Acon_ext =[Acon;Aeq;-Aeq];bcon_ext = [bcon;beq;-beq];
    
end
Acon2 = [Acon2,zeros(ngrid*3,1)];
gvar.Acon=Acon;gvar.Aeq=Aeq;gvar.bcon=bcon;gvar.beq=beq;gvar.ub=ub;gvar.lb=lb;
B = parg.data(1);
fkappa1=importdata('fkappa');
fkappa=str2func(fkappa1{1});
kappa = fkappa(N);
gamma_grid = linspace(0,sqrt(kappa/N),parg.data(4));
q = [0.9,0.95];
delta0(1,:)=[delta1,rrl];
delta0(2,:)=[delta11,rrl];
delta0(3,:)=[delta_new1,rrh-1e-2];
delta0(4,:)=[delta_new2,rrh-1e-2];
%delta0(5,:)=[delta_new3,rrl];

% [delta1,fval] = fmincon(@(delta)norm(delta3-delta),zeros(1,2*n+1),Acon,bcon,Aeq,beq,[],[],[],options); 


%================================================
%Bootstrap
%================================================
iter=1;
y = zeros(iter,length(q));boot=cell(1,iter);
for i = 1:iter
    K=1;
    tvalue1=100;
    %[delta,tvalue]=fminsearchcon(@(delta)intmoment( data,delta,gvar),delta1,lb,ub,Acon_ext,bcon_ext+1e-12);
    if constr_opt==0;
        [deltacan(1,:),fval1(1)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(1,:),Acon,bcon,Aeq,beq,lb,ub,[],options);
        [deltacan(2,:),fval1(2)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(2,:),Acon2,bcon2,Aeq,beq,lb,ub,[],options);
         [deltacan(3,:),fval1(3)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(3,:),Acon,bcon,Aeq,beq,lb,ub,[],options);
        [deltacan(4,:),fval1(4)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(4,:),Acon2,bcon2,Aeq,beq,lb,ub,[],options);
      [tvalue,deltaid]=min(fval1);
      delta=deltacan(deltaid,:);
    else
        
        [deltacan(1,:),fval1(1)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(1,:),Acon,bcon,Aeq,beq,lb,ub,[],options);
        %[deltacan(2,:),fval1(2)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(3,:),Acon,bcon,Aeq,beq,lb,ub,[],options);
        %[deltacan(3,:),fval1(3)]=fmincon(@(delta)intmoment( data,delta,gvar),delta0(5,:),Acon,bcon,Aeq,beq,lb,ub,[],options);

        [tvalue,deltaid]=min(fval1);
        delta=deltacan(deltaid,:);
    end
    while (abs(tvalue1-tvalue)>parg.data(3))&&(K<parg.data(2))
        delta1=delta;
        tvalue1=tvalue;
        [delta,tvalue]=fminsearchcon(@(delta)intmoment( data,delta,gvar),delta,lb,ub,Acon_ext,bcon_ext+1e-6);
        K=K+1;
        
    end
    
    %tvalue(i) = intmoment( data{i},delta1,gvar)
    
    
     [y(i,:),boot{i}] = bootstrap(B,delta,data,q,gamma_grid,kappa,gvar );
end
fileID = fopen('output.txt','w');
fprintf(fileID,'%12.8f ',fx,hnull,rrl,rrh,tvalue,y);
fclose(fileID);


