function [y,yy,beta,sigma,cr] = test(data,weight,gvar,beta0)
%compute the test statistic
options = optimset('algorithm','active-set','maxiter',1e4,'display','off');
warning off;
Bsplines = gvar.Bsplines;
DBsplines = gvar.DBsplines;
T = gvar.T;
Xgrid = gvar.Xgrid;
Y = data{1,1}(:);X = data{1,2}(:); Z = data{1,3}(:);
[~,n] = size(Bsplines);
%mm=floor(sqrt(gvar.n))+1;
mm=gvar.gridn;
nT = length(T);
%======================================
%Generate regressors and instruments
%======================================

% for i = 1:n;
%     genX(:,i) = interp1(Xgrid,Bsplines,X);
% end
genX =  interp1(Xgrid,Bsplines,X);
for i = 1:nT;
    %genZ(:,i) = weight((Z-mean(Z))/std(Z),T(i,:));
   genZ(:,i) = weight(Z,T(i,:));
end

%====================================
%Generate produce
%====================================
YZ = mean(repmat(Y,1,nT).*genZ)';
for i = 1:nT;
    XZ(i,:) = mean(genX.*repmat(genZ(:,i),1,n));
end

W = eye(nT);

Bmatrix = YZ'*W*XZ/nT;

Amatrix = XZ'*W*XZ/nT;

Cmatrix = (YZ'*W*YZ)/nT;
lb = -gvar.pbound*ones(n,1);
ub = -lb;
%Ineq_grid = linspace(min(X),max(X),mm);
Ineq_grid = linspace(gvar.lb,gvar.ub,mm);
Acon =-interp1(Xgrid,DBsplines,Ineq_grid);
bcon = zeros(mm,1);%ones(mm,1)/gvar.n;

[beta,fval] = quadprog(Amatrix,-Bmatrix,Acon,bcon,[],[],lb,ub,beta0,options);
[beta,fval] = quadprog(Amatrix,-Bmatrix,Acon,bcon,[],[],lb,ub,beta,options);

%[beta,fval] = quadprog(Amatrix,-Bmatrix,[],[],[],[],lb,ub,beta0,options);
y = (Cmatrix+2*fval)*gvar.n;
yy = (YZ - XZ*beta)'*W*(YZ - XZ*beta)*gvar.n/nT;

sigma = zeros(nT,1);
error = Y - genX*beta;
for i = 1:nT;
    gen_res(i,:) = error.*genZ(:,i);
end
% compute big sigma
SIGMA = XZ'*cov(gen_res')*XZ/gvar.nT^2+eye(n)/gvar.n;

%V = (genX'*genX)/ndata;
% compute W matrix
W = (genX'*genX)/gvar.n;

%compute convergence rate
Amatrix = Amatrix +eye(n)/gvar.n;
cr = sqrt(trace(W*pinv(Amatrix)*SIGMA*pinv(Amatrix)))/sqrt(gvar.n);



end
% beta= randn(n,1)
% y = Cmatrix-2*Bmatrix'*beta+beta'*Amatrix*beta;
% y=y*gvar.n;
% for i = 1:nT;
%     xx(i) = mean((Y-genX*beta).*weight(Z,T(i,:)))^2;
%    
% end
% xxx = mean(xx)*gvar.n;
%fval
%Cmatrix


