function [Tvalue,cvalue] = testing_mon_fun(dataopt,gamma_upper,B,samplesize,iter,model,scale,g)
%close all;
%load true.mat
%===================================
%Define parameters
%===================================
V = [1 0.5, 0.3;0.5 1 0;0.3 0 1];%knots=[-1,-0.5,0,.5,0.75,1,1.25,1.5,1.75,2];
if model>2
    knots=[linspace(-1,g.ub,g.aorder)];
else

knots=[linspace(-1,g.ub,g.norder)];
end
nT1=g.nT1;
nT2=g.nT2;
sorder =2; p=[.9,.95];
n = samplesize;ngrid = 1e4;
T = [repmat(linspace(-0.8,0.8,nT1),1,nT2);repmat(linspace(0.05,0.2,nT2),1,nT1)];
%T = [repmat(linspace(-1,1,20),1,20);repmat(linspace(0.05,0.3,20),1,20)];
%T = linspace(-g.maxT,g.maxT,600);
T=T';
lambda_func = importdata('lambda_func.txt');

lambdafun = str2func(lambda_func{1}) ;
lambda=lambdafun(n);
%gamma = linspace(0,gamma_upper/sqrt(n),10);
%=============================
%Generate and pass spline basis
%=============================
[ Bsplines, DBsplines, Xgrid] = Bspline_bases(knots,ngrid,sorder);
gvar.Bsplines = Bsplines;
gvar.DBsplines = DBsplines;
gvar.Xgrid = Xgrid;
gvar.n=samplesize;
gvar.T=T;
gvar.nT = length(T);
gvar.scale=scale;
gvar.lb = g.lb;
gvar.ub = g.ub;
gvar.gridn=g.gridn;
gvar.pbound=g.pbound;
%gvar.trueYZ =trueYZ;
%gvar.trueXZ = trueXZ;
%===============================================
%Define weight function
%===============================================

weight=@(z,t)normpdf((t(1)-z)/t(2),0,1);
%weight = @(z,t)exp(t.*atan(z));
%weight = @(z,t)exp(t.*z);

gvar.weight=weight;


%=========================================
%Generate data
%=========================================
%rf = @(x)x+exp(-50*x.^2);
if model==0
    rf = @(x)0.*x;
elseif model==1;
    rf = @(x)x-4*normpdf(x-1,0,1);
elseif model==2;
    rf = @(x)(1-x).*x;
else
    rf = @(x)x-8*normpdf((x-1.15),0,1);
end


 YY= rf(Xgrid);

beta0 = inv(Bsplines'*Bsplines)*(Bsplines'*YY);
%plot(Xgrid,YY,'red',Xgrid,Bsplines*beta0)
max(abs(YY - Bsplines*beta0))
norm(YY -Bsplines*beta0)
gvar.beta0=beta0;


rng('shuffle')


if dataopt==1
    
    sigma = 0.1;
    Z = rand(n,iter); %intstruments
    V1 = 2*rand(n,iter)-1;%error for instruments equation
    %V1 = randn(n,iter);
    E = V1 + randn(n,iter)*sigma; %error terms
    U  = Z+V1;
    W = rf(U)+E; %data
    for i= 1:iter;
        data{i,1} = W(:,i);
        data{i,2} = U(:,i);
        data{i,3} = Z(:,i);
    end
    
    
else
    
    for i = 1:iter;
        u{i}= randn(3,n);
        uu{i} = V^(1/2)*u{i};
        X{i} = 2*(normcdf(uu{i}(1,:)/3,0,1)-0.5);
        Z {i}= 2*(normcdf(uu{i}(2,:)/3,0,1)-0.5);
        Y{i}= rf(X{i})+uu{i}(3,:);
        data{i,1}=Y{i};
        data{i,2}=X{i};
        data{i,3}=Z{i};
    end
end
gvar.epsilon = log(n)/n;






gamma = linspace(0,sqrt(lambda/n),g.gamma_gridn);
gamma_step = importdata('step.txt');
gamma_step = [gamma_step,g.gamma_gridn-1];

for i = 1:iter;
i
    
    [yy,yy1,beta,sigma,EV] = test(data(i,:),weight,gvar,beta0);

    Tvalue(i) = yy1;
    beta1(:,i) = beta;
  tic
   cvalue(i,:) = monboots_min( data(i,:),gamma,lambda,p,B,gvar,gamma_step);

  toc

end
end


