clear;
close all
load final_results/rej90_longerN23_8_100_25.mat
rejN23=rej90;
load final_results/rej90_longerNlog_8_100_25.mat
rejNlog=rej90;

load final_results/rej95_longerN23_8_100_25.mat
rejN23_95=rej95;
load final_results/rej95_longerNlog_8_100_25.mat
rejNlog_95=rej95;

fx = linspace(0.1417,0.5017,10);

rej90_figNlog=figure
hold on
plot(fx(1:end-1),rejNlog(1:end-1,4),'-x','linewidth',2)
plot(fx(1:end-1),rejNlog(1:end-1,3),'-o','linewidth',2)
plot(fx(1:end-1),rejNlog(1:end-1,1),'-v','linewidth',2)

xlim([fx(1),fx(end-1)])
plot([fx(1),fx(end-1)],[0.1,0.1],'--g')
xlabel('Null value of $F_s(0.25)$','interpreter','latex')
ylabel('Rejection Probability')

legend('GLS','LF','MB1/MB3', 'location','northwest')
figure_halfpage
xticks([0.2,0.2617,0.35,0.4])
yx=gca;
yx.YTick=[0,0.1:0.1:1];
saveas(rej90_figNlog,'final_results/auction_rej90_Nlog_100_25','epsc')
saveas(rej90_figNlog,'final_results/auction_rej90_Nlog_100_25','png')


rej90_figN23=figure
hold on
plot(fx(1:end-1),rejN23(1:end-1,4),'-x','linewidth',2)
plot(fx(1:end-1),rejN23(1:end-1,3),'-o','linewidth',2)
plot(fx(1:end-1),rejN23(1:end-1,1),'-v','linewidth',2)

xlim([fx(1),fx(end-1)])
plot([fx(1),fx(end-1)],[0.1,0.1],'--g')
xlabel('Null value of $F_s(0.25)$','interpreter','latex')
legend('GLS','LF','MB1/MB3', 'location','northwest')
xticks([0.2,0.2617,0.35,0.4])
figure_halfpage
yx=gca;
yx.YTick=[0,0.1:0.1:1];
saveas(rej90_figN23,'final_results/auction_rej90_N23_100_25','epsc')
saveas(rej90_figN23,'final_results/auction_rej90_N23_100_25','png')

powercompare=figure
set(powercompare,'defaultLegendAutoUpdate','off')
hold on
plot(fx(1:end-1),rejNlog(1:end-1,1),'-x','linewidth',2)
plot(fx(1:end-1),rejN23(1:end-1,1),'-o','linewidth',2)
legend('$\kappa_n=n/ln(n)$','$\kappa_n=n^{2/3}$','location','northwest','Interpreter','latex')

plot([fx(1),fx(end-1)],[0.1,0.1],'--g')
xlim([fx(1),fx(end-1)])

xlabel('Null value of $F_s(0.25)$','interpreter','latex')
xticks([0.2,0.2617,0.35,0.4])
figure_halfpage
yx=gca;
yx.YTick=[0,0.1:0.1:1];
saveas(powercompare,'final_results/auction_pc_100_25','epsc')
saveas(powercompare,'final_results/auction_pc_100_25','png')


