function y_min = monboots_min( data,gamma,lambda,p,B,gvar,gamma_step)
%=====================================
%compute the bootstrap critical value
%=====================================
options = optimset('algorithm','active-set','maxiter',5e4,'display','off');
warning off;
%=======================================
%Passing Variables
%=======================================
mm = gvar.gridn;
Bsplines = gvar.Bsplines;
DBsplines = gvar.DBsplines;
pbound=gvar.pbound;
T = gvar.T;
Xgrid = gvar.Xgrid; weight = gvar.weight;
Y = data{1,1}(:);X = data{1,2}(:); Z = data{1,3}(:);
genX =  interp1(Xgrid,Bsplines,X);nT = gvar.nT;
[~,n] = size(Bsplines);
lb = -pbound*ones(n,1);
ub = -lb;
Ineq_grid = linspace(gvar.lb,gvar.ub,mm);
%Ineq_grid = linspace(min(X),max(X),mm);
Acon = -interp1(Xgrid,DBsplines,Ineq_grid);
bcon = zeros(mm,1)/gvar.n;
ndata = length(Y);
genZ=zeros(gvar.n,nT);
%mZ =mean(Z);sZ = std(Z);
%mZ=0;sZ=1;
for i = 1:nT;
    genZ(:,i) = weight(Z,T(i,:));
    %genZ(:,i) = weight((Z-mZ)/sZ,T(i,:));
    
end

XZ_cell = cell(1,nT);
for i = 1:nT;
    XZ_cell{1,i} = genX.*repmat(genZ(:,i),1,n);
    
end
W= eye(nT);

XZ = zeros(nT,n);
for j=1:nT;
    XZ(j,:) = mean(XZ_cell{1,j});
end
beta0=gvar.beta0;
XZs = zeros(nT,n);
YZ = mean(repmat(Y,1,nT).*genZ)';
Bmatrix2 = YZ'*W*XZ/nT;
Amatrix2 = XZ'*W*XZ/nT;
Cmatrix2 = (YZ'*W*YZ)/nT;
for i = 1:B;
    
    ID = ceil(rand(ndata,1)*ndata);
    Ys = Y(ID,:);
    genXs = genX(ID,:);
    genZs = genZ(ID,:);
    
    %===================================
    %Generate the Matrices
    %===================================
  

    YZs = mean(repmat(Ys,1,nT).*genZs)';

    for j = 1:nT;
        XZs(j,:) =  mean(genXs.*repmat(genZs(:,j),1,n));
    end
    
    for jj = 1:length(gamma);
        
        BYZ = (YZs - (1-gamma(jj))*YZ)*sqrt(ndata);
        BXZ = (XZs - (1-gamma(jj))*XZ)*sqrt(ndata);
        
        Bmatrix1 = BYZ'*W*BXZ/nT;
        lambda1 = abs(lambda - gamma(jj)^2*ndata);
        Amatrix1 = BXZ'*W*BXZ/nT;
        Cmatrix1 = (BYZ'*W*BYZ)/nT;

        Amatrix =Amatrix1+Amatrix2*lambda1;
        Bmatrix = -Bmatrix1-Bmatrix2*lambda1;
        Cmatrix = Cmatrix1+Cmatrix2*lambda1;
        
        [beta,fval] = quadprog(Amatrix,Bmatrix,Acon,bcon,[],[],lb,ub,beta0,options);
        [beta,fval] = quadprog(Amatrix,Bmatrix,Acon,bcon,[],[],lb,ub,beta,options);
        b1(jj) = fval*2+Cmatrix;
        b2(jj) = fval*2+Cmatrix-lambda1*(YZ-XZ*beta)'*W*(YZ-XZ*beta)/nT;
        
    end
    
    
    
    
    
    boots1(i,:) = b1;
    boots2(i,:) = b2;
end
if length(gamma)>1;
    y_min=[quantile(boots2(:,end),p),quantile(boots2(:,1),p)];
    for i = 1:length(gamma_step);
        
        y_min = [y_min,quantile(min(boots2(:,1:gamma_step(i):end),[],2),p)];
        
    end
else
    y_min = [quantile(boots1,p),quantile(boots2,p)];
end


